function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/* eslint-disable react/no-multi-comp, no-bitwise */
// import 'raf/polyfill'
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';
import { createDatavanContext, createDb } from '..';
Enzyme.configure({
  adapter: new Adapter()
});

var Indirection =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Indirection, _React$Component);

  function Indirection() {
    _classCallCheck(this, Indirection);

    return _possibleConstructorReturn(this, _getPrototypeOf(Indirection).apply(this, arguments));
  }

  _createClass(Indirection, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Indirection;
}(React.Component);

test('memoize', function () {
  var collections = {
    users: {}
  };
  var Van = createDatavanContext(collections);
  var globalDb = createDb(collections);

  var getter = function getter(_db) {
    return _db.getById('users').x;
  };

  var App = function App() {
    return React.createElement(Van.Provider, {
      db: globalDb
    }, React.createElement(Indirection, null, React.createElement(Van, {
      observe: "users"
    }, function (db) {
      return React.createElement("button", {
        type: "button"
      }, db.memoize(getter));
    })));
  };

  var wrapper = mount(React.createElement(App, null));
  var btn = wrapper.find('button');
  expect(btn.text()).toBe('');
  globalDb.set('users', 'x', 2);
  expect(btn.text()).toBe('2');
});
test('mutate and get back', function () {
  var Van = createDatavanContext({
    users: {}
  });

  var App = function App() {
    return React.createElement(Van.Provider, null, React.createElement(Indirection, null, React.createElement(Van, {
      observe: "users"
    }, function (db) {
      return React.createElement("button", {
        type: "button",
        onClick: function onClick() {
          return db.set('users', 'x', 2);
        }
      }, db.getById('users').x);
    })));
  };

  var wrapper = mount(React.createElement(App, null));
  var btn = wrapper.find('button');
  expect(btn.text()).toBe('');
  btn.simulate('click');
  expect(btn.text()).toBe('2');
});