"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = _interopRequireWildcard(require("enzyme"));

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

var _ = require("..");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

_enzyme.default.configure({
  adapter: new _enzymeAdapterReact.default()
});

var Indirection =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Indirection, _React$Component);

  function Indirection() {
    _classCallCheck(this, Indirection);

    return _possibleConstructorReturn(this, _getPrototypeOf(Indirection).apply(this, arguments));
  }

  _createClass(Indirection, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Indirection;
}(_react.default.Component);

test('memoize', function () {
  var collections = {
    users: {}
  };
  var Van = (0, _.createDatavanContext)(collections);
  var globalDb = (0, _.createDb)(collections);

  var getter = function getter(_db) {
    return _db.getById('users').x;
  };

  var App = function App() {
    return _react.default.createElement(Van.Provider, {
      db: globalDb
    }, _react.default.createElement(Indirection, null, _react.default.createElement(Van, {
      observe: "users"
    }, function (db) {
      return _react.default.createElement("button", {
        type: "button"
      }, db.memoize(getter));
    })));
  };

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(App, null));
  var btn = wrapper.find('button');
  expect(btn.text()).toBe('');
  globalDb.set('users', 'x', 2);
  expect(btn.text()).toBe('2');
});
test('mutate and get back', function () {
  var Van = (0, _.createDatavanContext)({
    users: {}
  });

  var App = function App() {
    return _react.default.createElement(Van.Provider, null, _react.default.createElement(Indirection, null, _react.default.createElement(Van, {
      observe: "users"
    }, function (db) {
      return _react.default.createElement("button", {
        type: "button",
        onClick: function onClick() {
          return db.set('users', 'x', 2);
        }
      }, db.getById('users').x);
    })));
  };

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(App, null));
  var btn = wrapper.find('button');
  expect(btn.text()).toBe('');
  btn.simulate('click');
  expect(btn.text()).toBe('2');
});